## pistache 0.0.5%2Bds

=== tests/fuzzers/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2021 David Korczynski
#
# SPDX-License-Identifier: Apache-2.0

add_executable(fuzz_parser fuzz_parser.cpp)
target_link_libraries(fuzz_parser pistache_static)
set_target_properties(fuzz_parser PROPERTIES LINK_FLAGS $ENV{LIB_FUZZING_ENGINE})

=== debian/control ===
Source: pistache
Section: libs
Priority: optional
Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13)
Build-Depends-Arch: dpkg-dev (>= 1.22.5), cmake,
                    libcpp-httplib-dev <!nocheck>,
                    libcurl4-openssl-dev | libcurl-dev <!nocheck>,
                    libgmock-dev (>= 1.11.0) <!nocheck>,
                    libhowardhinnant-date-dev,
                    libssl-dev,
                    meson (>= 0.50.0),
                    pkg-config,
                    rapidjson-dev
Standards-Version: 4.6.2
Homepage: https://pistacheio.github.io/pistache/
Vcs-Git: https://salsa.debian.org/debian/pistache.git
Vcs-Browser: https://salsa.debian.org/debian/pistache
Rules-Requires-Root: no

Package: libpistache0t64
Provides: ${t64:Provides}
Replaces: libpistache0
Breaks: libpistache0 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: elegant C++ REST framework
 Pistache is a modern and elegant HTTP and REST framework for C++.
 It is entirely written in pure C++17 and provides a clear and pleasant API.
 .
 Pistache provides both an HTTP server and client that can be used to create and
 query complex web and REST APIs.
 .
 This package contains the shared library built with TLS support.

Package: libpistache-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libpistache0t64 (= ${binary:Version}),
         libssl-dev,
         rapidjson-dev,
         ${misc:Depends}
Description: elegant C++ REST framework - development files
 Pistache is a modern and elegant HTTP and REST framework for C++.
 It is entirely written in pure C++17 and provides a clear and pleasant API.
 .
 Pistache provides both an HTTP server and client that can be used to create and
 query complex web and REST APIs.
 .
 This package contains the development headers, static library, and examples.
 The static library was built with TLS support.

## pistache 0.0.5+ds

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2015 Mathieu Stefani
#
# SPDX-License-Identifier: Apache-2.0

cmake_minimum_required (VERSION 3.11)

set(CMAKE_BUILD_TYPE_INIT Release)

file(READ "version.txt" VERSION_FILE_RAW)
string(STRIP "${VERSION_FILE_RAW}" VERSION_FILE)

project (pistache
    LANGUAGES C CXX
    VERSION ${VERSION_FILE})

add_compile_options(-Wall -Wextra -Wpedantic -Wconversion -Wno-sign-conversion -Wno-missing-field-initializers)

option(BUILD_SHARED_LIBS "build shared library" ON)
option(PISTACHE_BUILD_TESTS "build tests alongside the project" OFF)
option(PISTACHE_ENABLE_FLAKY_TESTS "if tests are built, also run ones that are known to be flaky" ON)
option(PISTACHE_ENABLE_NETWORK_TESTS "if tests are built, run ones needing network access" ON)
option(PISTACHE_USE_SSL "add support for SSL server" OFF)
option(PISTACHE_PIC "Enable pistache PIC" ON)
option(PISTACHE_BUILD_FUZZ "Build fuzzer for oss-fuzz" OFF)

# require fat LTO objects in static library
if(CMAKE_INTERPROCEDURAL_OPTIMIZATION OR CMAKE_CXX_FLAGS MATCHES "-flto" OR CMAKE_CXX_FLAGS MATCHES "-flto=thin")
    if(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
        add_compile_options(-ffat-lto-objects)
    elseif(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
        add_compile_options(-flto=full)
    endif()
endif()

set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)

if (PISTACHE_USE_SSL)
    find_package(OpenSSL REQUIRED COMPONENTS SSL Crypto)
endif ()

# Set version numbers in a header file

set(VERSION_MAJOR    ${pistache_VERSION_MAJOR})
set(VERSION_MINOR    ${pistache_VERSION_MINOR})
set(VERSION_PATCH    ${pistache_VERSION_PATCH})
set(VERSION_GIT_DATE ${pistache_VERSION_TWEAK})
configure_file (
    "include/pistache/version.h.in"
    "include/pistache/version.h"
    @ONLY
)

add_subdirectory (src)

if (PISTACHE_BUILD_TESTS)
    include(CTest)
    find_package(GTest QUIET)
    if (NOT GTEST_FOUND)
    message("GoogleTest not found. Consider installing it on your system. Downloading it from source...")
    include(FetchContent)
        FetchContent_Declare(
            googletest
            GIT_REPOSITORY https://github.com/google/googletest.git
            GIT_SHALLOW true
        )
        set(BUILD_GMOCK OFF CACHE BOOL "")
        FetchContent_GetProperties(googletest)
        if(NOT googletest_POPULATED)
            FetchContent_Populate(googletest)
            add_subdirectory(${googletest_SOURCE_DIR} ${googletest_BINARY_DIR})
        endif()
    endif()
    add_subdirectory(tests)
endif()

if (PISTACHE_BUILD_FUZZ) 
    add_subdirectory(tests/fuzzers)
endif()

# format target

add_custom_target(format
    COMMAND
        ./tools/format.sh
    WORKING_DIRECTORY
        ${CMAKE_CURRENT_SOURCE_DIR}
)

# CMake 3.21 defines this automatically
if (PROJECT_IS_TOP_LEVEL OR CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
    install(CODE "message(FATAL_ERROR \"Please use Meson to install Pistache.
See the README for details: https://github.com/pistacheio/pistache#building-from-source\")")
endif()

=== meson_options.txt ===
# SPDX-FileCopyrightText: 2021 Andrea Pappacoda
#
# SPDX-License-Identifier: Apache-2.0

option('PISTACHE_BUILD_TESTS', type: 'boolean', value: false, description: 'build tests alongside the project')
option('PISTACHE_BUILD_EXAMPLES', type: 'boolean', value: false, description: 'build examples alongside the project')
option('PISTACHE_BUILD_DOCS', type: 'boolean', value: false, description: 'build docs alongside the project')
option('PISTACHE_INSTALL', type: 'boolean', value: true, description: 'add pistache as install target (recommended)')
option('PISTACHE_USE_SSL', type: 'boolean', value: false, description: 'add support for SSL server')

=== src/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2015 Mathieu Stefani
#
# SPDX-License-Identifier: Apache-2.0

file (GLOB COMMON_SOURCE_FILES "common/*.cc")
file (GLOB SERVER_SOURCE_FILES "server/*.cc")
file (GLOB CLIENT_SOURCE_FILES "client/*.cc")

file (GLOB INCLUDE_FILES ${PROJECT_SOURCE_DIR}/include/pistache/*h)

set(SOURCE_FILES
    ${COMMON_SOURCE_FILES}
    ${SERVER_SOURCE_FILES}
    ${CLIENT_SOURCE_FILES}
    ${INCLUDE_FILES}
)

add_library(pistache OBJECT ${SOURCE_FILES})
set_target_properties(pistache PROPERTIES POSITION_INDEPENDENT_CODE ${PISTACHE_PIC})
target_compile_features(pistache PRIVATE cxx_std_17)
add_definitions(-DONLY_C_LOCALE=1)

set(PISTACHE_INCLUDE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../include>
)

find_package(RapidJSON QUIET)
if (NOT RapidJSON_FOUND)
    message("RapidJSON not found. Consider installing it on your system. Downloading it from source...")
    include(FetchContent)
    FetchContent_Declare(
        RapidJSON
        GIT_REPOSITORY https://github.com/Tencent/rapidjson.git
        GIT_TAG v1.1.0
        GIT_SHALLOW true
    )
    set(RAPIDJSON_BUILD_DOC OFF CACHE BOOL "")
    set(RAPIDJSON_BUILD_EXAMPLES OFF CACHE BOOL "")
    set(RAPIDJSON_BUILD_TESTS OFF CACHE BOOL "")
    if(NOT RapidJSON_POPULATED)
        FetchContent_Populate(RapidJSON)
        add_subdirectory(${rapidjson_SOURCE_DIR} ${rapidjson_BINARY_DIR})
    endif()
    target_include_directories(pistache PRIVATE ${rapidjson_SOURCE_DIR}/include)
else()
    target_include_directories(pistache PRIVATE ${RAPIDJSON_INCLUDE_DIRS})
endif()

target_include_directories(pistache PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/../subprojects/hinnant-date/include)
target_include_directories(pistache PUBLIC ${PISTACHE_INCLUDE})

if (BUILD_SHARED_LIBS)
    add_library(pistache_shared SHARED $<TARGET_OBJECTS:pistache>)
    target_link_libraries(pistache_shared PRIVATE Threads::Threads ${CMAKE_REQUIRED_LIBRARIES})
    target_include_directories(pistache_shared INTERFACE ${PISTACHE_INCLUDE})
endif ()

add_library(pistache_static STATIC $<TARGET_OBJECTS:pistache>)
target_link_libraries(pistache_static PRIVATE Threads::Threads ${CMAKE_REQUIRED_LIBRARIES})
target_include_directories(pistache_static INTERFACE ${PISTACHE_INCLUDE})

if (PISTACHE_USE_SSL)
    target_compile_definitions(pistache PUBLIC PISTACHE_USE_SSL)
    target_compile_definitions(pistache_static PUBLIC PISTACHE_USE_SSL)

    target_include_directories(pistache PRIVATE ${OPENSSL_INCLUDE_DIR})
    target_link_libraries(pistache_static PUBLIC OpenSSL::SSL OpenSSL::Crypto)
    if (BUILD_SHARED_LIBS)
        target_compile_definitions(pistache_shared PUBLIC PISTACHE_USE_SSL)
        target_link_libraries(pistache_shared PUBLIC OpenSSL::SSL OpenSSL::Crypto)
    endif ()
endif ()

if (BUILD_SHARED_LIBS)
    set_target_properties(pistache_shared PROPERTIES
        OUTPUT_NAME ${PROJECT_NAME}
        VERSION ${pistache_VERSION}
        SOVERSION ${pistache_VERSION_MAJOR}
    )
endif ()

set_target_properties(pistache_static PROPERTIES
    OUTPUT_NAME ${PROJECT_NAME}
)

=== tests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2015 Mathieu Stefani
#
# SPDX-License-Identifier: Apache-2.0

find_package(CURL REQUIRED)

function(pistache_test test_name)
    set(TEST_EXECUTABLE run_${test_name})
    set(TEST_SOURCE ${test_name}.cc)

    add_executable(${TEST_EXECUTABLE} ${TEST_SOURCE})
    target_include_directories(${TEST_EXECUTABLE} PRIVATE
        ${CURL_INCLUDE_DIRS}
        ${CMAKE_SOURCE_DIR}/subprojects/hinnant-date/include
        ${CMAKE_SOURCE_DIR}/subprojects/cpp-httplib
    )
    # CMake 3.20 and upstream GTest define GTest::gtest, older versions define GTest::GTest
    if (TARGET GTest::gtest)
        target_link_libraries(${TEST_EXECUTABLE} GTest::gtest GTest::gtest_main pistache_static ${CURL_LIBRARIES})
    else ()
        target_link_libraries(${TEST_EXECUTABLE} GTest::GTest GTest::Main pistache_static ${CURL_LIBRARIES})
    endif ()
    add_test(${test_name} ${TEST_EXECUTABLE})
endfunction()


pistache_test(mime_test)
pistache_test(headers_test)
pistache_test(async_test)
pistache_test(typeid_test)
pistache_test(router_test)
pistache_test(cookie_test)
pistache_test(cookie_test_2)
pistache_test(cookie_test_3)
pistache_test(view_test)
pistache_test(http_parsing_test)
pistache_test(http_uri_test)
pistache_test(http_server_test)
pistache_test(http_client_test)
if (PISTACHE_ENABLE_NETWORK_TESTS)
    pistache_test(net_test)
endif (PISTACHE_ENABLE_NETWORK_TESTS)
pistache_test(listener_test)
pistache_test(request_size_test)
pistache_test(streaming_test)
pistache_test(rest_server_test)
pistache_test(mailbox_test)
pistache_test(stream_test)
pistache_test(reactor_test)
pistache_test(threadname_test)
pistache_test(log_api_test)
pistache_test(string_logger_test)
pistache_test(endpoint_initialization_test)

if (PISTACHE_USE_SSL)

    configure_file("certs/server.crt" "certs/server.crt" COPYONLY)
    configure_file("certs/server.key" "certs/server.key" COPYONLY)
    configure_file("certs/client.key" "certs/client.key" COPYONLY)
    configure_file("certs/client.crt" "certs/client.crt" COPYONLY)
    configure_file("certs/rootCA.crt" "certs/rootCA.crt" COPYONLY)
    configure_file("certs/server_from_intermediate_with_chain.crt" "certs/server_from_intermediate_with_chain.crt" COPYONLY)
    configure_file("certs/server_from_intermediate.crt" "certs/server_from_intermediate.crt" COPYONLY)
    configure_file("certs/server_from_intermediate.key" "certs/server_from_intermediate.key" COPYONLY)
    configure_file("certs/intermediateCA.crt" "certs/intermediateCA.crt" COPYONLY)
    configure_file("certs/server_protected.crt" "certs/server_protected.crt" COPYONLY)
    configure_file("certs/server_protected.key" "certs/server_protected.key" COPYONLY)

    pistache_test(https_server_test)
endif (PISTACHE_USE_SSL)

=== debian/changelog ===
pistache (0.0.5+ds-5.1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:20:15 +1100

pistache (0.0.5+ds-5.1build1) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 21:03:42 +0000

pistache (0.0.5+ds-5.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063257

 -- Benjamin Drung <bdrung@debian.org>  Thu, 29 Feb 2024 20:52:06 +0000

pistache (0.0.5+ds-5) unstable; urgency=medium

  * d/patches: add missing cstdint include (Closes: #1037819)

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sat, 15 Jul 2023 23:42:58 +0200

pistache (0.0.5+ds-4) unstable; urgency=medium

  * d/rules: disable network tests.
    See <https://github.com/pistacheio/pistache/pull/1134>

 -- Andrea Pappacoda <andrea@pappacoda.it>  Fri, 23 Jun 2023 17:18:26 +0200

pistache (0.0.5+ds-3) unstable; urgency=medium

  * d/patches: fix DoS in the TLS listener

 -- Andrea Pappacoda <andrea@pappacoda.it>  Wed, 08 Mar 2023 11:11:29 +0100

pistache (0.0.5+ds-2) unstable; urgency=medium

  * Source-only upload

 -- Andrea Pappacoda <andrea@pappacoda.it>  Thu, 02 Feb 2023 21:37:21 +0100

pistache (0.0.5+ds-1) unstable; urgency=low

  * Initial release. Closes: #929593

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sat, 03 Sep 2022 12:30:54 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: pistache
 Section: libs
 Priority: optional
-Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
 Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13)
 Build-Depends-Arch: dpkg-dev (>= 1.22.5), cmake,
                     libcpp-httplib-dev <!nocheck>,

=== debian/watch ===
version=4
opts="searchmode=plain, \
  filenamemangle=s/.+\/@ANY_VERSION@/@PACKAGE@-$1\.tar\.gz/, \
  pgpmode=none, \
  repacksuffix=+ds, \
  dversionmangle=auto" \
https://api.github.com/repos/pistacheio/pistache/tags \
https://api.github.com/repos/pistacheio/pistache/tarball/refs/tags/@ANY_VERSION@

## pistache 0.4.26+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,39 @@
 
 cmake_minimum_required (VERSION 3.11)
 
-set(CMAKE_BUILD_TYPE_INIT Release)
+set(CMAKE_CXX_STANDARD 17)
+set(CMAKE_CXX_STANDARD_REQUIRED ON)
+set(CMAKE_CXX_EXTENSIONS OFF)
+
+# @Feb/2024 - CMAKE_BUILD_TYPE_INIT is not defined in cmake documentation?
+# CMAKE_BUILD_TYPE is defined however
+# set(CMAKE_BUILD_TYPE_INIT Release)
+
+# Options are here, before project command, so we can use them in
+# choosing whether to set CMAKE_OSX_DEPLOYMENT_TARGET
+option(BUILD_SHARED_LIBS "build shared library" ON)
+option(PISTACHE_BUILD_TESTS "build tests alongside the project" ON)
+option(PISTACHE_ENABLE_FLAKY_TESTS "if tests are built, also run ones that are known to be flaky" OFF)
+option(PISTACHE_ENABLE_NETWORK_TESTS "if tests are built, run ones needing network access" OFF)
+option(PISTACHE_USE_SSL "add support for SSL server" OFF)
+option(PISTACHE_PIC "Enable pistache PIC" ON) # Position-independent code lib
+option(PISTACHE_BUILD_FUZZ "Build fuzzer for oss-fuzz" OFF)
+
+string(TOLOWER "${CMAKE_HOST_SYSTEM_NAME}" CMAKE_HOST_SYSTEM_NAME_LOWER)
+
+if (CMAKE_HOST_SYSTEM_NAME_LOWER MATCHES "darwin")
+  if (PISTACHE_BUILD_TESTS OR PISTACHE_ENABLE_FLAKY_TESTS OR
+      PISTACHE_ENABLE_NETWORK_TESTS)
+    # On macOS (Dec/2023, Sonoma 14.2.1), GTest, installed by brew, used
+    # by pistache tests, requires macOS 14 or later
+
+    # Note: Must set CMAKE_OSX_DEPLOYMENT_TARGET before project
+    # command which means we can't test CMAKE_CXX_COMPILER_ID or APPLE
+    # which are not set until after project command
+    set(ENV{MACOSX_DEPLOYMENT_TARGET} "14.0")
+    set(CMAKE_OSX_DEPLOYMENT_TARGET "14.0")
+  endif()
+endif()
 
 file(READ "version.txt" VERSION_FILE_RAW)
 string(STRIP "${VERSION_FILE_RAW}" VERSION_FILE)
@@ -13,15 +45,20 @@
     LANGUAGES C CXX
     VERSION ${VERSION_FILE})
 
+# Must have "project" before can check for Clang/Apple/CMAKE_SYSTEM_PROCESSOR
+if(CMAKE_CXX_COMPILER_ID MATCHES "Clang" AND APPLE AND
+    CMAKE_SYSTEM_PROCESSOR MATCHES "arm64")
+  set(CMAKE_OSX_ARCHITECTURES "arm64" CACHE INTERNAL "" FORCE)
+endif()
+
+if(CMAKE_BUILD_TYPE MATCHES "Debug")
+  add_compile_options(-DDEBUG=1)
+endif()
+
+# add_compile_options(-fsanitize=address)
+# add_link_options(-fsanitize=address)
+
 add_compile_options(-Wall -Wextra -Wpedantic -Wconversion -Wno-sign-conversion -Wno-missing-field-initializers)
-
-option(BUILD_SHARED_LIBS "build shared library" ON)
-option(PISTACHE_BUILD_TESTS "build tests alongside the project" OFF)
-option(PISTACHE_ENABLE_FLAKY_TESTS "if tests are built, also run ones that are known to be flaky" ON)
-option(PISTACHE_ENABLE_NETWORK_TESTS "if tests are built, run ones needing network access" ON)
-option(PISTACHE_USE_SSL "add support for SSL server" OFF)
-option(PISTACHE_PIC "Enable pistache PIC" ON)
-option(PISTACHE_BUILD_FUZZ "Build fuzzer for oss-fuzz" OFF)
 
 # require fat LTO objects in static library
 if(CMAKE_INTERPROCEDURAL_OPTIMIZATION OR CMAKE_CXX_FLAGS MATCHES "-flto" OR CMAKE_CXX_FLAGS MATCHES "-flto=thin")
@@ -30,6 +67,15 @@
     elseif(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
         add_compile_options(-flto=full)
     endif()
+endif()
+
+# On Linux, libraries by default compile allowing external symbols to be
+# unresolved until the time of linking an executable (i.e. of linking
+# the library to the executable). On macOS by contrast we need to define
+# this "-undefined dynamic_lookup" option to avoid link errors on
+# linking the library when there are external dependencies
+if(CMAKE_CXX_COMPILER_ID MATCHES "Clang" AND APPLE)
+set(CMAKE_SHARED_LIBRARY_CREATE_CXX_FLAGS "${CMAKE_SHARED_LIBRARY_CREATE_CXX_FLAGS} -undefined dynamic_lookup")
 endif()
 
 set(THREADS_PREFER_PTHREAD_FLAG ON)
@@ -53,6 +99,8 @@
 
 add_subdirectory (src)
 
+# For info on GTest::gtest GTest::gmock_main, see Pistache's
+# tests/CMakeLists.txt
 if (PISTACHE_BUILD_TESTS)
     include(CTest)
     find_package(GTest QUIET)
@@ -62,6 +110,7 @@
         FetchContent_Declare(
             googletest
             GIT_REPOSITORY https://github.com/google/googletest.git
+            GIT_TAG "origin/main"
             GIT_SHALLOW true
         )
         set(BUILD_GMOCK OFF CACHE BOOL "")

=== meson_options.txt ===
--- 
+++ 
@@ -7,3 +7,10 @@
 option('PISTACHE_BUILD_DOCS', type: 'boolean', value: false, description: 'build docs alongside the project')
 option('PISTACHE_INSTALL', type: 'boolean', value: true, description: 'add pistache as install target (recommended)')
 option('PISTACHE_USE_SSL', type: 'boolean', value: false, description: 'add support for SSL server')
+option('PISTACHE_USE_RAPIDJSON', type: 'boolean', value: true, description: 'add support for rapidjson')
+option('PISTACHE_USE_CONTENT_ENCODING_BROTLI', type: 'boolean', value: false, description: 'add support for Brotli compressed content encoding')
+option('PISTACHE_USE_CONTENT_ENCODING_ZSTD', type: 'boolean', value: false, description: 'add support for Zstandard compressed content encoding')
+option('PISTACHE_USE_CONTENT_ENCODING_DEFLATE', type: 'boolean', value: false, description: 'add support for deflate compressed content encoding')
+option('PISTACHE_DEBUG', type: 'boolean', value: false, description: 'with debugging code')
+option('PISTACHE_LOG_AND_STDOUT', type: 'boolean', value: false, description: 'send log msgs to stdout too')
+option('PISTACHE_FORCE_LIBEVENT', type: 'boolean', value: false, description: 'force use of libevent')

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -75,7 +75,7 @@
     set_target_properties(pistache_shared PROPERTIES
         OUTPUT_NAME ${PROJECT_NAME}
         VERSION ${pistache_VERSION}
-        SOVERSION ${pistache_VERSION_MAJOR}
+        SOVERSION "${pistache_VERSION_MAJOR}.${pistache_VERSION_MINOR}"
     )
 endif ()

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -4,22 +4,71 @@
 
 find_package(CURL REQUIRED)
 
+add_subdirectory(helpers)
+
+# Enable access to lib and inc files in our local pistache branch
+# Note: PROJECT_BINARY_DIR is full path to build dir of the most
+# recent project() command.
+include_directories(BEFORE ${PROJECT_BINARY_DIR}/../include)
+link_directories(BEFORE ${PROJECT_BINARY_DIR}/src)
+
+# Enable access to brew-installed lib and inc files, including gtest
+if(CMAKE_CXX_COMPILER_ID MATCHES "Clang" AND APPLE)
+  include_directories(AFTER ${HOMEBREW_PREFIX}/include)
+  link_directories(AFTER ${HOMEBREW_PREFIX}/lib)
+endif()
+
 function(pistache_test test_name)
     set(TEST_EXECUTABLE run_${test_name})
     set(TEST_SOURCE ${test_name}.cc)
 
     add_executable(${TEST_EXECUTABLE} ${TEST_SOURCE})
+
+    # On macOS (Dec/2023, Sonoma 14.2.1), GTest installed by brew
+    # requires C++14 or later
+    # Also, pistache header files use nested namespace definitions,
+    # which is a C++17 extension per macOS error message
+    # This target_compile_features might be a good idea on Linux too?
+    if(CMAKE_CXX_COMPILER_ID MATCHES "Clang" AND APPLE)           
+      target_compile_features(${TEST_EXECUTABLE} PRIVATE cxx_std_17)
+    endif()
+
     target_include_directories(${TEST_EXECUTABLE} PRIVATE
         ${CURL_INCLUDE_DIRS}
         ${CMAKE_SOURCE_DIR}/subprojects/hinnant-date/include
         ${CMAKE_SOURCE_DIR}/subprojects/cpp-httplib
     )
-    # CMake 3.20 and upstream GTest define GTest::gtest, older versions define GTest::GTest
-    if (TARGET GTest::gtest)
-        target_link_libraries(${TEST_EXECUTABLE} GTest::gtest GTest::gtest_main pistache_static ${CURL_LIBRARIES})
+
+    if(CMAKE_CXX_COMPILER_ID MATCHES "Clang" AND APPLE)
+      # Apparently need gmock gtest AND gtest_main
+      # https://github.com/google/googletest/issues/1404
+      if (PISTACHE_USE_SSL)
+        target_link_libraries(${TEST_EXECUTABLE} gmock gtest gtest_main
+          ssl crypto
+          pistache tests_helpers event event_pthreads ${CURL_LIBRARIES})
+      else ()
+        target_link_libraries(${TEST_EXECUTABLE} gmock gtest gtest_main
+          pistache tests_helpers event event_pthreads ${CURL_LIBRARIES})
+      endif (PISTACHE_USE_SSL)
+
     else ()
-        target_link_libraries(${TEST_EXECUTABLE} GTest::GTest GTest::Main pistache_static ${CURL_LIBRARIES})
-    endif ()
+      # NOT macOS
+      # CMake 3.20 and upstream GTest define GTest::gtest, older versions define GTest::GTest
+      
+      # On Ubuntu 22.04 (Jan 2024), got GTest::gtest GTest::gmock_main
+      # correctly defined by installing as per this gist's
+      # install_gtest_gmock.sh:
+      #   https://gist.github.com/dlime/313f74fd23e4267c4a915086b84c7d3d
+      #
+      # Can remove "event event_pthreads" below if not forcing 
+      if (TARGET GTest::gtest)
+        target_link_libraries(${TEST_EXECUTABLE} GTest::gtest GTest::gmock_main
+          pistache_static tests_helpers event event_pthreads ${CURL_LIBRARIES})
+      else ()
+        target_link_libraries(${TEST_EXECUTABLE} GTest::GTest GMock::Main pistache_static tests_helpers event event_pthreads ${CURL_LIBRARIES})
+      endif ()
+    endif()
+
     add_test(${test_name} ${TEST_EXECUTABLE})
 endfunction()
 
@@ -51,6 +100,7 @@
 pistache_test(log_api_test)
 pistache_test(string_logger_test)
 pistache_test(endpoint_initialization_test)
+pistache_test(helpers_test)
 
 if (PISTACHE_USE_SSL)

=== tests/helpers/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 Mikhail Khachayants
#
# SPDX-License-Identifier: Apache-2.0

add_library(tests_helpers STATIC fd_utils.cc fd_utils.h)
target_compile_features(tests_helpers PRIVATE cxx_std_17)

=== debian/changelog ===
pistache (0.4.26+ds-3) unstable; urgency=medium

  * Upload to unstable. Closes: #1097591
  * d/watch: update to version 5

 -- Andrea Pappacoda <tachi@debian.org>  Thu, 18 Sep 2025 17:20:59 +0200

pistache (0.4.26+ds-2) experimental; urgency=low

  * Retry upload to experimental.
    This is the first time I push a NEW package, sorry!

 -- Andrea Pappacoda <andrea@pappacoda.it>  Tue, 24 Dec 2024 16:43:55 +0100

pistache (0.4.26+ds-1) experimental; urgency=low

  * New upstream version 0.4.26+ds
  * First dgit upload
  * d/control: libpistache0 -> libpistache0.4
  * d/control: apply X-Style: black
  * d/control: declare dpkg-build-api = 1
  * d/README.source: document packaging workflow
  * d/patches: drop upstreamed patches

 -- Andrea Pappacoda <andrea@pappacoda.it>  Tue, 24 Dec 2024 15:33:20 +0100

=== debian/control ===
Source: pistache
Section: libs
Priority: optional
Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
Build-Depends:
 debhelper-compat (= 13),
 dpkg-dev (>= 1.22.5),
 dpkg-build-api (= 1),
Build-Depends-Arch:
 cmake,
 libcpp-httplib-dev <!nocheck>,
 libcurl4-openssl-dev | libcurl-dev <!nocheck>,
 libgmock-dev (>= 1.11.0) <!nocheck>,
 libhowardhinnant-date-dev,
 libssl-dev,
 meson (>= 0.50.0),
 pkg-config,
 rapidjson-dev,
Standards-Version: 4.7.0
Homepage: https://pistacheio.github.io/pistache/
Vcs-Git: https://salsa.debian.org/debian/pistache.git
Vcs-Browser: https://salsa.debian.org/debian/pistache
X-Style: black

Package: libpistache0.4
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: elegant C++ REST framework
 Pistache is a modern and elegant HTTP and REST framework for C++.
 It is entirely written in pure C++17 and provides a clear and pleasant API.
 .
 Pistache provides both an HTTP server and client that can be used to create and
 query complex web and REST APIs.
 .
 This package contains the shared library built with TLS support.

Package: libpistache-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libpistache0.4 (= ${binary:Version}),
 libssl-dev,
 rapidjson-dev,
 ${misc:Depends},
Description: elegant C++ REST framework - development files
 Pistache is a modern and elegant HTTP and REST framework for C++.
 It is entirely written in pure C++17 and provides a clear and pleasant API.
 .
 Pistache provides both an HTTP server and client that can be used to create and
 query complex web and REST APIs.
 .
 This package contains the development headers, static library, and examples.
 The static library was built with TLS support.

=== debian/rules ===
#!/usr/bin/make -f

# optimize=-lto because I use Meson's LTO
export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto qa=+all
# Required as libpistache-dev ships .a files
export DEB_CXXFLAGS_MAINT_APPEND = -ffat-lto-objects

%:
	dh $@ --buildsystem=meson

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
  test := true
else
  test := false
endif

override_dh_auto_configure:
	dh_auto_configure -- \
		--default-library=both \
		-Db_lto=true \
		-DPISTACHE_BUILD_TESTS=$(test) \
		-DPISTACHE_USE_SSL=true

override_dh_auto_test:
	dh_auto_test -- --no-suite=network

=== debian/tests/control ===
Tests:
 pkgconfig,
Depends:
 g++ | c++-compiler,
 pkg-config,
 @,

=== debian/watch ===
Version: 5

Template: GitHub
Owner: pistacheio
Project: pistache
Dversionmangle: auto
Repacksuffix: +ds
